using SushiBarContracts.StoragesContracts;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SushiBarFileImplement.Implements
{
    public class BackUpInfo : IBackUpInfo
    {
        private readonly DataFileSingleton _fileSingleton;

        public BackUpInfo()
        {
            _fileSingleton = DataFileSingleton.GetInstance();
        }

        public List<T>? GetList<T>() where T : class, new()
        {
            return (List<T>?)_fileSingleton.GetType().GetProperties()
                 .FirstOrDefault(x => x.PropertyType.IsGenericType && x.PropertyType.GetGenericArguments()[0] == typeof(T))
                 ?.GetValue(_fileSingleton);
        }
        public Type? GetTypeByModelInterface(string modelInterfaceName)
        {
            var assembly = typeof(BackUpInfo).Assembly;
            var types = assembly.GetTypes();
            foreach (var type in types)
            {
                if (type.IsClass &&
                type.GetInterface(modelInterfaceName) != null)
                {
                    return type;
                }
            }
            return null;
        }
    }
}
